#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "thumbnailmanager.h"
#include <QtGui>
MainWindow::MainWindow ( QWidget *parent ) :
        QMainWindow ( parent ),
        ui ( new Ui::MainWindow )
{
    ui->setupUi ( this );
    this->statusLabel=new QLabel(this);
    this->statusLabel->setOpenExternalLinks(true);
    this->statusBar()->addWidget(this->statusLabel);
    //connect
    connect ( ui->browseButton,SIGNAL ( clicked() ),this,SLOT ( browseSourceFolder() ) );
    connect ( ui->browseDest_button,SIGNAL ( clicked() ),this,SLOT ( browseDestinationFolder()) );

    connect ( ui->source_lineEdit,SIGNAL ( textChanged ( QString ) ),this,SLOT ( sourceSelectionChanged ( QString ) ) );
    connect ( ui->okButton_,SIGNAL ( clicked() ),this,SLOT ( proced() ) );
    connect ( ui->exit_button,SIGNAL ( clicked() ),this,SLOT ( close() ) );
    manager=new ThumbnailManager();
    connect ( this->manager,SIGNAL ( update ( QString ) ),this,SLOT ( updateMyStatus ( QString ) ) );

updateMyStatus( "<a href='http://simion314.isgreat.org/mainpage/main.html'> http://simion314.isgreat.org</a>" );
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::changeEvent ( QEvent *e )
{
    QMainWindow::changeEvent ( e );
    switch ( e->type() )
    {
    case QEvent::LanguageChange:
        ui->retranslateUi ( this );
        break;
    default:
        break;
    }
}

void MainWindow::browseSourceFolder()
{
    QFileDialog dialog;
    dialog.setFileMode ( QFileDialog::Directory );
    dialog.exec();
    QString fileName =dialog.selectedFiles().at ( 0 );
    this->ui->source_lineEdit->setText ( fileName );
}

void MainWindow::browseDestinationFolder()
{
    QFileDialog dialog;
    dialog.setFileMode ( QFileDialog::Directory );
    dialog.exec();
    QString fileName =dialog.selectedFiles().at ( 0 );
    this->ui->destination_lineEdit->setText ( fileName );
}


void MainWindow::sourceSelectionChanged ( QString path )
{
    QFileInfo fi ( path );
    if ( !fi.exists() )
    {
        //this->ui->source_lineEdit->
        return;
    }
    if ( fi.isDir() )
    {
        ui->destination_lineEdit->setText ( fi.path() +fi.baseName() +"_resized" );
    }
    else
    {
        QString file ( fi.path() );
        file=file+"/"+fi.baseName() +"_resized."+fi.suffix();
        ui->destination_lineEdit->setText ( file );
    }
}

void MainWindow::proced()
{
    QMessageBox msgBox;

    QFileInfo path ( ui->source_lineEdit->text() );
    if ( !path.exists() )
    {
        msgBox.setText ( "This Folder/Fule does not exists "+path.path() );
        msgBox.exec();
        return;
    }

    QSize rSize ( ui->width_spinBox->value(),ui->hegith_spinBox->value() );
    if ( path.isDir() )
    {
        QDir sourceDir ( path.absoluteFilePath() );
        QString destination=ui->destination_lineEdit->text();
        if ( !sourceDir.exists ( destination ) )
        {
            bool res= sourceDir.mkdir ( destination );
            if ( !res )
            {
                msgBox.setText ( "This Folder  does not exists and can't be created "+destination );
                msgBox.exec();
                return;
            }
        }
        if ( QFileInfo ( destination ).path().startsWith ( sourceDir.absolutePath() ) )
        {
            msgBox.setText ( "The destination Folder must be outside the source folder "+destination );
            msgBox.exec();
            return;
        }
        manager->resizeFolderImages ( sourceDir,destination,rSize );
    }
    else
    {
        bool res=manager->resizeImage ( path.path(),QSize ( 200,200 ) );
        if ( !res )
        {
            msgBox.setText ( "The operation on the file faield" );
            msgBox.exec();
        }
    }
    updateMyStatus( "Ready" );
}

void MainWindow::updateMyStatus ( QString s )
{
    this->statusLabel->setText ( s );;
}
