#include "thumbnailmanager.h"
#include <QtGui>
#include<QtCore>
ThumbnailManager::ThumbnailManager()
{
}

bool ThumbnailManager::resizeImage(QString filePath,const QSize  & size)
{
    QImage image(filePath);
    if(image.isNull()) return false;
    QImage res=image.scaled(size,Qt::KeepAspectRatio);
    if(res.isNull())return false;
    QFileInfo fi(filePath);
    QString name=fi.baseName();
    QString dir=fi.path();
    QString ext=fi.suffix();
    QString save=dir+"/"+name+"_resized."+ext;
    return res.save(save);
}
bool ThumbnailManager::resizeImage(QString filePath,const QString &destination,const QSize  & size)
{
    QImage image(filePath);
    if(image.isNull()) return false;
    QImage res=image.scaled(size,Qt::KeepAspectRatio);
    if(res.isNull())return false;
    return res.save(destination);
}

void ThumbnailManager::resizeFolderImages(QDir source,const QString destination,const QSize &size)
{   
   source.setFilter(QDir::AllEntries  | QDir::NoDotAndDotDot  | QDir::AllDirs);
    QFileInfoList list=source.entryInfoList();
    int length=list.count();
    for(int i=0;i<length;i++)
    {
        QDir dir;
        QFileInfo file=list.at(i);
        if(file.isDir())
        {

            QString dname=file.fileName();
            QString newDir=destination+"/"+dname;
            if(!dir.exists(newDir))
            {dir.mkdir(newDir);}

            update("Enter in folder: "+file.absoluteFilePath());
            this->resizeFolderImages(QDir(file.absoluteFilePath()),newDir,size);

        }
        else
        {
            QString name=file.fileName();
            QString fileDest=destination+"/"+name;
            bool res=this->resizeImage(file.absoluteFilePath(),fileDest,size);
            if(res)
            {
                update("Resized: "+file.absoluteFilePath());
            }
            else
            {
                update("Faield resizing: "+file.absoluteFilePath());
            }
        }
        QCoreApplication::processEvents();// processEvents()
    }
}

